"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const AuthProvider_1 = require("../AuthProvider");
class AnonymousAuthProvider extends AuthProvider_1.AuthProvider {
    constructor() {
        super(...arguments);
        this.name = 'anonymous';
    }
    authenticateOrCreateUser(body) {
        return __awaiter(this, void 0, void 0, function* () {
            const id = this.service['generateUniqueId']();
            return this.service.createOrUpdateUser(id, this.name, false);
        });
    }
}
exports.AnonymousAuthProvider = AnonymousAuthProvider;
//# sourceMappingURL=AnonymousAuthProvider.js.map