import { User } from "../../realms/AdminRealm";
import { AuthProvider } from "../AuthProvider";
export interface AzureAuthProviderConfig {
    tenant_id: string;
    skipVerification?: boolean;
}
export declare class AzureAuthProvider extends AuthProvider {
    name: string;
    private readonly tenantId;
    private readonly skipVerification;
    constructor(config: AzureAuthProviderConfig);
    authenticateOrCreateUser(body: any): Promise<User>;
    private httpGet(uri);
    private validateSignature(accessToken, keys, kid);
}
