import { User } from "../../realms/AdminRealm";
import { AuthProvider } from "../AuthProvider";
export interface JwtAuthProviderConfig {
    publicKey: string;
    userIdFieldName?: string;
    isAdminFieldName?: string;
    isAdminValue?: any;
    providerName?: string;
    requiredAttributes?: {
        [key: string]: any;
    };
    charactersToEscape?: string[];
}
export declare class JwtAuthProvider extends AuthProvider {
    name: string;
    private readonly publicKey;
    private readonly userIdFieldName;
    private readonly isAdminFieldName;
    private readonly isAdminValue;
    private readonly requiredAttributes;
    private readonly charactersToEscape;
    constructor(config: JwtAuthProviderConfig);
    authenticateOrCreateUser(body: any): Promise<User>;
    private escapeUserId(userId);
    private verifyAndDecode(token);
}
