import { RealmDefinition } from "../../RealmFactory";
import * as Realm from 'realm';
export declare class PasswordSaltHash {
    static schema: Realm.ObjectSchema;
    userId: string;
    salt: string;
    iterations: number;
    keyLength: number;
    digest: string;
    hash: string;
    isEmailConfirmed: boolean;
}
export declare class PasswordResetRequest {
    static schema: Realm.ObjectSchema;
    token: string;
    userId: string;
    expires: Date;
    consumed?: Date;
}
export declare class EmailConfirmationRequest {
    static schema: Realm.ObjectSchema;
    token: string;
    userId: string;
    email: string;
    expires: Date;
    consumed?: Date;
}
export declare const PasswordRealm: RealmDefinition;
