#!/usr/bin/env node
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const BasicServer_1 = require("./BasicServer");
const termsofservice_1 = require("./termsofservice");
function main() {
    return __awaiter(this, void 0, void 0, function* () {
        if (process.argv.length === 3 && process.argv[2] === "start") {
            yield termsofservice_1.agreeToTerms();
        }
        try {
            const server = new BasicServer_1.BasicServer();
            yield server.run(process.argv);
        }
        catch (err) {
            console.log(err);
            process.exit(1);
        }
    });
}
main();
//# sourceMappingURL=cli.js.map