/// <reference types="node" />
import * as http from "http";
import * as promClient from "prom-client";
import { ConsoleLogger } from "../shared/Logger";
export interface KubernetesServerConfiguration {
    labels?: {
        [name: string]: string;
    };
}
export declare class KubernetesServer {
    protected unhandledRejectionCallback: (reason, promise) => void;
    protected readonly logger: ConsoleLogger;
    protected internalServer: http.Server;
    protected readonly registry: promClient.Registry;
    protected ready: boolean;
    constructor(config?: KubernetesServerConfiguration);
    start(): Promise<void>;
    shutdown(): Promise<void>;
    protected getMetrics(): string;
}
