import { User } from "../realms";
import { ServiceClientBase } from "./ServiceClientBase";
export declare class AuthClient extends ServiceClientBase {
    protected serviceName: string;
    protected baseRoute: string;
    revokeToken(token: string): Promise<{}>;
    getUserById(userId: string): Promise<User>;
    updateProviderData(provider: string, userId: string, data: any): Promise<any>;
    deleteUser(userId: string): Promise<{}>;
    requestPasswordReset(username: string): Promise<{}>;
    completePasswordReset(token: string, newPassword: string): Promise<{}>;
    requestEmailConfirmation(username: string): Promise<{}>;
    completeEmailConfirmation(token: string): Promise<{}>;
    updateProviderAccount(provider: string, data: any, providerId?: string, token?: string): Promise<{}>;
    getProviders(): Promise<{
        type: string;
        name: string;
        config?: any;
    }[]>;
    removeProvider(name: string): Promise<{}>;
    addProvider(type: string, config?: any, name?: string): Promise<{}>;
}
