"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const superagent = require("superagent");
const ServiceClientBase_1 = require("./ServiceClientBase");
class PermissionsClient extends ServiceClientBase_1.ServiceClientBase {
    constructor() {
        super(...arguments);
        this.serviceName = 'permissions';
        this.baseRoute = 'permissions';
    }
    onDemand(token) {
        return __awaiter(this, void 0, void 0, function* () {
            const route = yield this.getRoute('ondemand');
            const request = superagent.get(route);
            return yield this.executeRequest(request, token);
        });
    }
    applyPermissions(changeRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            const route = yield this.getRoute('apply');
            const request = superagent.post(route)
                .send(changeRequest);
            return yield this.executeRequest(request);
        });
    }
}
exports.PermissionsClient = PermissionsClient;
//# sourceMappingURL=PermissionsClient.js.map