"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const superagent = require("superagent");
const URI = require("urijs");
const ServiceClientBase_1 = require("./ServiceClientBase");
const AdminRealm_1 = require("../realms/AdminRealm");
class RealmDirectoryClient extends ServiceClientBase_1.ServiceClientBase {
    constructor() {
        super(...arguments);
        this.serviceName = 'realms';
        this.baseRoute = 'realms';
    }
    findByPath(params) {
        return __awaiter(this, void 0, void 0, function* () {
            let route = yield this.getRoute('files', params.realmPath);
            const query = {
                shouldCreate: params.shouldCreate
            };
            if (params.shouldCreate) {
                query.realmType = params.realmType || AdminRealm_1.RealmType.full;
            }
            if (params.ownerId) {
                query.ownerId = params.ownerId;
            }
            route = new URI(route).query(query).toString();
            const request = superagent.get(route);
            return yield this.executeRequest(request, params.token);
        });
    }
}
exports.RealmDirectoryClient = RealmDirectoryClient;
//# sourceMappingURL=RealmDirectoryClient.js.map