/// <reference types="superagent" />
import * as superagent from 'superagent';
import { Discovery } from '../discovery/Discovery';
import { ServiceHandle } from '../discovery/ServiceHandle';
export declare abstract class ServiceClientBase {
    protected discovery: Discovery;
    protected adminToken: string;
    private authorizationHeaderName;
    private tags;
    protected abstract serviceName: string;
    protected abstract baseRoute: string;
    constructor(discovery: Discovery, adminToken: string, authorizationHeaderName: string, tags?: string[]);
    protected getRoute(...segments: string[]): Promise<string>;
    protected findService(): Promise<ServiceHandle>;
    protected executeRequest(request: superagent.SuperAgentRequest, token?: string): Promise<any>;
}
