/// <reference types="express" />
import * as express from 'express';
import { AuthClient } from '../../service-clients/AuthClient';
import { Logger } from '../../shared/Logger';
import { Server } from '../../Server';
export declare class PasswordAuthUIService {
    protected authClient: AuthClient;
    protected logger: Logger;
    start(server: Server): Promise<void>;
    getConfirmEmail(res: express.Response, token: string, redirectUrl: string): Promise<void>;
    getResetPassword(res: express.Response, token: string, redirectUrl: string): Promise<void>;
    postResetPassword(res: express.Response, redirectUrl: string, email: string, token: string, password: string, passwordRepeated: string): Promise<void>;
    protected parseErrorMessage(intent: string, err: any): string;
}
