"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Token_1 = require("./Token");
const chai_1 = require("chai");
describe("UserToken", () => {
    it("Valid UserToken", () => {
        const params = {
            identity: "user-id",
            appId: "app-id",
            expires: 123456,
            salt: "salt",
            isAdmin: false,
        };
        const token = new Token_1.UserToken(params);
        chai_1.assert.strictEqual(token.identity, "user-id");
        chai_1.assert.isFalse(token.isAdmin);
        chai_1.assert.strictEqual(token.expires, 123456);
        const json = token.toJSON();
        chai_1.assert.strictEqual(json.identity, "user-id");
        chai_1.assert.isFalse(json.is_admin);
    });
});
//# sourceMappingURL=Token.spec.js.map