"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const jwt = require("jsonwebtoken");
function loadFeatureToken(token) {
    const decoded = jwt.decode(token);
    if (decoded) {
        const expires = new Date(decoded.iat * 1000);
        const capabilities = Object.keys(decoded).filter(k => decoded[k] === true);
        return { capabilities, expires };
    }
    else {
        throw new Error("Could not decode feature token.");
    }
}
exports.loadFeatureToken = loadFeatureToken;
//# sourceMappingURL=featureToken.js.map