"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const chai_1 = require("chai");
const util = require("./util");
describe("getUserIdFromRealmPath", function () {
    it("full sync path", function () {
        chai_1.assert.strictEqual(util.getUserIdFromRealmPath("/user1/products"), "user1");
        chai_1.assert.strictEqual(util.getUserIdFromRealmPath("/user1/products/item"), "user1");
        chai_1.assert.strictEqual(util.getUserIdFromRealmPath("/user1/"), "user1");
    });
    it("partial sync path", function () {
        chai_1.assert.strictEqual(util.getUserIdFromRealmPath("/user1/__partial/user2/random"), "user2");
        chai_1.assert.strictEqual(util.getUserIdFromRealmPath("/user1/products/__partial/user2/random"), "user2");
        chai_1.assert.strictEqual(util.getUserIdFromRealmPath("/user1/products/__partial/user2"), "user2");
    });
});
//# sourceMappingURL=util.spec.js.map