"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const path = require("path");
function mapVirtToRealmPath(rootPath, virtPath) {
    if (virtPath === "" || !virtPath.startsWith("/")) {
        return null;
    }
    let result = rootPath;
    const [head, ...tail] = virtPath.split("/");
    for (const segment of tail) {
        if (!validVirtPathSegment(segment)) {
            return null;
        }
        result = path.resolve(result, segment);
    }
    return result + ".realm";
}
exports.mapVirtToRealmPath = mapVirtToRealmPath;
const badSuffixes = [".realm", ".realm.lock", ".realm.management"];
const alphanumRegex = /^[0-9a-zA-Z\-_\.]+$/;
function validVirtPathSegment(segment) {
    if (segment === "") {
        return false;
    }
    if (segment.startsWith(".")) {
        return false;
    }
    if (badSuffixes.some(s => segment.endsWith(s))) {
        return false;
    }
    if (!alphanumRegex.test(segment)) {
        return false;
    }
    return true;
}
//# sourceMappingURL=virtPath.js.map