import { StatsLabels } from "./StatsLabels";
import { StatsStorage } from "./StatsStorage";
import { StatsSink, StatsMetricParams, StatsCounter, StatsGauge } from "./StatsSink";
import { StatsHistogram, StatsTimerCallback } from "./index";
export declare type LabelledValue = {
    labels: StatsLabels;
    value: number;
};
export declare class SimpleStatsMetric {
    name: string;
    help: string;
    protected values: LabelledValue[];
    constructor(params: StatsMetricParams);
    getValuesWithLabelNames(labelNames: string[]): number[];
    getValues(labels: StatsLabels): number[];
    protected getValue(labels: StatsLabels): LabelledValue;
}
export declare class SimpleStatsCounter extends SimpleStatsMetric implements StatsCounter {
    inc(labels: StatsLabels, value?: number): void;
    reset(labels: StatsLabels, value?: number): void;
}
export declare class SimpleStatsGauge extends SimpleStatsCounter implements StatsGauge {
    dec(labels: StatsLabels, value?: number): void;
    set(labels: StatsLabels, value: number): void;
}
export declare class SimpleStatsHistogram extends SimpleStatsMetric implements StatsHistogram {
    observe(labels: StatsLabels, value: number): void;
    startTimer(labels: StatsLabels): StatsTimerCallback;
}
export declare class SimpleStats implements StatsSink, StatsStorage {
    private metrics;
    counter(params: StatsMetricParams): StatsCounter;
    gauge(params: StatsMetricParams): StatsGauge;
    histogram(params: StatsMetricParams): StatsHistogram;
    getValues(name: string, labels: StatsLabels): Promise<number[]>;
    getValuesWithLabelNames(name: string, labelNames: string[]): Promise<number[]>;
}
